// Digital_Scope_Menus.h 0.92 by Earl Colby Pottinger.
// Constants Messages for menu commands.

//////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_FILE_NEW       = 'new_'; // Clear all buffers.                //
const uint32 MENU_FILE_OPEN      = 'open'; // Load a file into buffer.          //
const uint32 MENU_FILE_CLOSE     = 'clse'; // Close loading a file into buffer. //
const uint32 MENU_FILE_SAVE      = 'save'; // Save buffer into a file.          //
const uint32 MENU_FILE_SAVEAS    = 'svas'; // Save buffer into a file.          //
const uint32 MENU_FILE_PAGESETUP = 'page'; // Setup page margins.               //
const uint32 MENU_FILE_PRINT     = 'prnt'; // Print data.                       //
const uint32 MENU_FILE_PREFS     = 'pref'; // Program preferences.              //
//////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_FILE_PREFS_OPTIONS = 'prfo'; // Toggle Input Option Display. //
const uint32 MENU_FILE_PREFS_TESTS   = 'prft'; // Toggle Tests Display.        //
/////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_FILE_PREFS_DISPLAY  = 'prf0'; // Set colour of the Display background.       //
const uint32 MENU_FILE_PREFS_GRID     = 'prf1'; // Set colour of the Grid lines.               //
const uint32 MENU_FILE_PREFS_BULLsEYE = 'prf2'; // Set colour of the Bull's Eye lines.         //
const uint32 MENU_FILE_PREFS_DIGITAL  = 'prf3'; // Set colour of the Digital Data lines.       //
const uint32 MENU_FILE_PREFS_ZERO     = 'prf4'; // Set colour of the Digital Zero Level lines. //
const uint32 MENU_FILE_PREFS_ANALOG1  = 'prf5'; // Set colour of the Analog 1 Data.            //
const uint32 MENU_FILE_PREFS_ANALOG2  = 'prf6'; // Set colour of the Analog 2 Data.            //
const uint32 MENU_FILE_PREFS_ANALOG3  = 'prf7'; // Set colour of the Analog 3 Data.            //
const uint32 MENU_FILE_PREFS_ANALOG4  = 'prf8'; // Set colour of the Analog 4 Data.            //
/////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_FILE_ABOUT = 'what'; // About the program. //
const uint32 MENU_FILE_QUIT  = 'quit'; // Exit program.      //
///////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_EDIT_UNDO    = 'undo'; // Reverse last changes.                //
const uint32 MENU_EDIT_CUT     = 'cut_'; // Move selected data to clipboard.     //
const uint32 MENU_EDIT_COPY    = 'copy'; // Copy selected data to clipboard.     //
const uint32 MENU_EDIT_PASTE   = 'pste'; // Paste clipboard to present position. //
const uint32 MENU_EDIT_SELECT  = 'all_'; // Select all data.                     //
const uint32 MENU_EDIT_FIND    = 'find'; // Find data sequence.                  //
const uint32 MENU_EDIT_REPLACE = 'rplc'; // Replace data sequence.               //
/////////////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_AUDIO_CARD       = 'aud1'; // Read Sound Card Audio lines in.                        //
const uint32 MENU_JOY_DIGITAL      = 'joyd'; // Read Digital Joystick lines in.                        //
const uint32 MENU_JOY_ANALOG       = 'joya'; // Read Analog Joystick lines in.                         //
const uint32 MENU_JOY_DIRECT       = 'joyr'; // Read Joystick registers directly.                      //
const uint32 MENU_JOY_BASIC        = 'joyb'; // Read Joystick using BJoyStick() in 'Basic' mode.       //
const uint32 MENU_JOY_ENHANCED     = 'joye'; // Read Joystick using BJoyStick() in 'Enhanced' mode.    //
const uint32 MENU_PARALLEL_DIGITAL = 'ppdg'; // Read Parallel Port Digital lines in.                   //
const uint32 MENU_BAR_ADC08        = 'brs8'; // Read Analog lines, 8 LEDs Bar ADC in.                  //
const uint32 MENU_BAR_ADC10        = 'bs10'; // Read Analog lines, 10 LED Bar ADC in.                  //
const uint32 MENU_1_4_ADC          = 'sf04'; // Read Analog lines, Single Flash 4-Bit ADCs in.         //
const uint32 MENU_2_4_ADC          = 'df04'; // Read Analog lines, Dual Flash 4-Bit ADCs in.           //
const uint32 MENU_08_ADC           = 'sf08'; // Read Analog lines, Single Flash 8-Bit ADC in.          //
const uint32 MENU_12_ADC           = 'sf12'; // Read Analog lines, Single Flash 12-Bit ADC in.         //
const uint32 MENU_SCAN_RAMP        = 'scnr'; // Scan using a ramp (255-0) for one 8 bit analog value.  //
const uint32 MENU_SS_TRACK         = 'tkss'; // Track using Single-Steps for one 8 bit analog value.   //
const uint32 MENU_MS_TRACK         = 'tkms'; // Track using Multiple-Steps for one 8 bit analog value. //
const uint32 MENU_SUC_APPX         = 'acax'; // Track using Successive Approximation-Steps.            //
/////////////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_INPUT_SIGNALS_1 = 'sig1'; // Read 1 Signal line.  //
const uint32 MENU_INPUT_SIGNALS_2 = 'sig2'; // Read 2 Signal lines. //
const uint32 MENU_INPUT_SIGNALS_4 = 'sig4'; // Read 4 Signal lines. //
const uint32 MENU_INPUT_SIGNALS_6 = 'sig6'; // Read 6 Signal lines. //
const uint32 MENU_INPUT_SIGNALS_8 = 'sig8'; // Read 8 Signal lines. //
///////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_READ_SOUND     = 'rsnd'; // Read sound buffers.                                //
const uint32 MENU_READ_GAME1     = 'rgm1'; // Read values off Joystick buttons inputs directly.  //
const uint32 MENU_READ_GAME2     = 'rgm2'; // Read values off Joystick analog timing directly.   //
const uint32 MENU_READ_GAME3     = 'rgm3'; // Read values off Basic Joystick inputs.             //
const uint32 MENU_READ_GAME4     = 'rgm4'; // Read values off Enhanced Joystick inputs.          //
const uint32 MENU_READ_PORT      = 'prtr'; // Read a value off parallel port's inputs.           //
const uint32 MENU_COUNT_UP       = 'prtu'; // Count up parallel output.                          //
const uint32 MENU_COUNT_DOWN     = 'prtd'; // Count down parallel output.                        //
const uint32 MENU_WRITE_PORT_0   = 'prt0'; // Write a value of '0' on parallel port's outputs.   //
const uint32 MENU_WRITE_PORT_85  = 'prt8'; // Write a value of '85' on parallel port's outputs.  //
const uint32 MENU_WRITE_PORT_170 = 'prt1'; // Write a value of '170' on parallel port's outputs. //
const uint32 MENU_WRITE_PORT_255 = 'prt2'; // Write a value of '255' on parallel port's outputs. //
const uint32 MENU_SCAN_PLOT      = 'mspt'; // Sample and plot data.                              //
const uint32 MENU_FAKE_SCAN      = 'fake'; // Fake a data scan.                                  //
const uint32 MENU_RESTORE        = 'rstr'; // Restore default settings.                          //
const uint32 MENU_GRID_SWCTH     = 'grid'; // Change display of grid modes.                      //
const uint32 MENU_BULLS_EYE      = 'bull'; // Turn display of bull's eye on/off.                 //
const uint32 MENU_NORMAL         = 'norm'; // Normal scaling of analog plotting.                 // 
const uint32 MENU_MAX            = 'maxm'; // Maxinize scaling of analog plotting.               //
const uint32 APP_SCAN_PLOT       = 'splt'; // Sample and plot data.                              //
///////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 APP_SLEEP       = 'slep'; // Go to sleep for one second. //
const uint32 MENU_CENTER     = 'cntr'; // Center all analog displays. //
const uint32 MENU_OFFSET     = 'ofst'; // Offset all analog displays. //
const uint32 REFRESH_DISPLAY = 'rfhd'; // Force redraw of display.    //
////////////////////////////////////////////////////////////////////////
const uint32 COLOUR_CHANGED = 'clch'; // New colour picked.           //
const uint32 COLOUR_SET = 'cset';     // Set colour of prefs control. //
const uint32 COLOUR_OK = 'clok';      // Finished changing colour.    //
////////////////////////////////////////////////////////////////////////
const uint32 MENU_TIMING_1 = 'tmg0'; // 1 sample per second.       //
const uint32 MENU_TIMING_2 = 'tmg1'; // 10 samples per second.     //
const uint32 MENU_TIMING_3 = 'tmg2'; // 100 samples per second.    //
const uint32 MENU_TIMING_4 = 'tmg3'; // 1000 samples per second.   //
const uint32 MENU_TIMING_5 = 'tmg4'; // 10000 samples per second.  //
const uint32 MENU_TIMING_6 = 'tmg5'; // 100000 samples per second. //
const uint32 MENU_TIMING_7 = 'tmg6'; // MAX samples per second.    //
//////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_TRIGGER_NONE     = 'trgn'; // No Trigger needed.                      //
const uint32 MENU_TRIGGER_RISING   = 'trgr'; // Trigger scan if signal rises.           //
const uint32 MENU_TRIGGER_FALLING  = 'trgf'; // Trigger scan if signal falls.           //
const uint32 MENU_TRIGGER_MID      = 'trgm'; // Trigger scan if signal cross mid value. //
const uint32 MENU_TRIGGER_ON_VALUE = 'trgv'; // Trigger scan if signal equals value.    //
/////////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_PULSE_OFF = 'pls0'; // Sends a pulse message to BApplication to turn off Pulses. //
const uint32 MENU_PULSE_0   = 'pls1'; // Sends a pulse message to BApplication, every .1 seconds.  //
const uint32 MENU_PULSE_1   = 'pls2'; // Sends a pulse message to BApplication, every 1 seconds.   //
const uint32 MENU_PULSE_10  = 'pls3'; // Sends a pulse message to BApplication, every 10 seconds.  //
const uint32 MENU_PULSE_100 = 'pls4'; // Sends a pulse message to BApplication, every 100 seconds. //
/////////////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_PULSE_NONE   = 'plsn'; // Turns off Pulse functions.                       //
const uint32 MENU_PULSE_SCAN   = 'plsc'; // On Pulse start standard scan/plot function.      //
const uint32 MENU_PULSE_SAMPLE = 'plsm'; // On Pulse sample a single Joystick analog sample. //
///////////////////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_DEBUG_HELP    = 'dbgh'; // Toggle Help function. //
const uint32 MENU_DEBUG_DISPLAY = 'dbdd'; // Reset Display.        //
///////////////////////////////////////////////////////////////////////////////////
const uint32 MENU_DEBUG_OFF  = 'dbg0'; // DeBug off.                             //
const uint32 MENU_DEBUG_1    = 'dbg1'; // DeBug RefsReceived.                    //
const uint32 MENU_DEBUG_2    = 'dbg2'; // DeBug Confirm load, save, save-as.     //
const uint32 MENU_DEBUG_3    = 'dbg3'; // DeBug App::ReadyToRun function called. //
const uint32 MENU_DEBUG_4    = 'dbg4'; // DeBug App::Pulse function called       //
const uint32 MENU_DEBUG_5    = 'dbg5'; // DeBug Beep() feedback.                 //
const uint32 MENU_DEBUG_6    = 'dbg6'; // DeBug .                                //
const uint32 MENU_DEBUG_7    = 'dbg7'; // DeBug .                                //
const uint32 MENU_DEBUG_8    = 'dbg8'; // DeBug .                                //
const uint32 MENU_DEBUG_9    = 'dbg9'; // DeBug .                                //
///////////////////////////////////////////////////////////////////////////////////////////
// Slider BMessages.  Used to adjust analog data display.                                //
const uint32 SLIDER_1 = 'sld1', SLIDER_2 = 'sld2', SLIDER_3 = 'sld3', SLIDER_4 = 'sld4'; //
const uint32 SLIDER_7 = 'sld7', SLIDER_5 = 'sld5', SLIDER_6 = 'sld6', SLIDER_8 = 'sld8'; //
const uint32 SLIDER_9 = 'sld9', SLIDER_0 = 'sld0', SLIDER_A = 'slda', SLIDER_B = 'sldb'; //
///////////////////////////////////////////////////////////////////////////////////////////
