// Digital_Scope_View.h
class Digital_Scope_View : public BView {                   // Define the class object Digital_Scope_View.
 public:       Digital_Scope_View(BRect frame, char *name); // Constructor for a view inside a window.
  virtual void Draw(BRect updateRect); } ;                  // Called by the OS when 'aWindow->Show()' used.

// Digital_Display_View.h
class Digital_Display_View : public BView {                   // Define the class object Digital_Display_View.
 public:       Digital_Display_View(BRect frame, char *name); // Constructor for a view inside a window.
  virtual void Draw(BRect updateRect); } ;                    // Called by the OS when 'aWindow->Show()' used.

// Digital_Colour_View.h
class Digital_Colour_View : public BView {                   // Define the class object Digital_Colour_View.
 public:       Digital_Colour_View(BRect frame, char *name); // Constructor for a view inside a window.
  virtual void Draw(BRect updateRect); } ;                   // Called by the OS when 'aWindow->Show()' used.

// Digital_Scope_Window.h
class Digital_Scope_Window : public BWindow {      // Define the class object Digital_Scope_Window.
 public:       Digital_Scope_Window(BRect frame);  // Constructor for a window thread.
  virtual bool QuitRequested();                    // Add function is close box is clicked.
  virtual void MessageReceived(BMessage *message); // Setup to recieve menu & windows messages.
  virtual void FrameMoved(BPoint new_position);    // Window moved to new position.
  BSlider     *slider1, *slider2, *slider3, *slider4, *slider5, *slider6, *slider7, *slider8, *slider9, *slider0, *sliderA, *sliderB;
  BMenuItem   *menuitem;
 private:
  BMenuBar     *menubar; } ;                       // Define object to hold all menu structures.

// Digital_Colour_Window.h
class Digital_Colour_Window : public BWindow {     // Define the class object Digital_Colour_Window.
 public:       Digital_Colour_Window(BRect frame); // Constructor for a window thread.
  virtual bool QuitRequested();                    // Add function is close box is clicked.
  virtual void MessageReceived(BMessage *message); // Setup to recieve menu & windows messages.
  virtual void FrameMoved(BPoint new_position); } ;

// Digital_Scope_World.h
class Digital_Scope_Application : public BApplication { // Define the class object Digital_Scope_Application.
 public:       Digital_Scope_Application();             // Constructor for an application thread.
               ~Digital_Scope_Application();            // Deconstructor for an application thread.
  virtual void ReadyToRun();                            // Called before BLooper starts
  virtual void AboutRequested();                        // Recieved a B_ABOUT_REQUESTED message.
  virtual void MessageReceived(BMessage *message);      // Recieves system or control messages.
  virtual void RefsReceived(BMessage *message);         // Recieves entry_ref messages from file panel.
  virtual void Pulse(); } ;                             // Recieved a B_PULSE message.

// Variables needed with windows.
BPoint         Window_Location1; // Position of Digital_Scope_Window on screen.
BPoint         Window_Location2; // Position of Digital_Scope_Window on screen.

BRect            aWindow1_Rect; // Dimension of window.
BRect            aWindow2_Rect; // Dimension of window.

BRect             aView1_Rect; // Dimensions of view inside window.
BRect             aView2_Rect; // Dimension of scope's display inside window.
BRect             aView3_Rect; // Dimension of colour control's view inside window.

Digital_Scope_View    *aView1; // Create a pointer(*aView1) to an object(Digital_Scope_View).
Digital_Display_View  *aView2; // Create a pointer(*aView2) to an object(Digital_Display_View).
Digital_Colour_View   *aView3; // Create a pointer(*aView3) to an object(Digital_Colour_View).

Digital_Scope_Window  *aWindow1; // Create a pointer(*aWindow1) to an object(Digital_Scope_Window).
Digital_Colour_Window *aWindow2; // Create a pointer(*aWindow2) to an object(Digital_Colour_Window).

/********************************************************************************************************************************************************************************************************************/
