// Digital_Display_View.cpp
Digital_Display_View::Digital_Display_View(BRect rect, char *name) : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW) { } // Define 'Digital_Display_View' constructor call.

void Digital_Display_View::Draw(BRect updateRect) { // Draws in view when show is called.
 float X, Y; // Needed local variables.  If Global variables used the drawing in more than one view interfers with each other.
 SetViewColor(displayColor);

 if (Display == 0) { // First Time info.
    SetFontSize(12); X=20.0; Y=20.0; MovePenTo(BPoint(X,Y));
    DrawString("Welcome to the Analog Signal and Digital Logic Scope version 0.92."); Y=Y+25.0; MovePenTo(BPoint(X,Y));

    DrawString("This program has been written to support the largest possible range of standard I/O hardware that can be found on most PC and Mac computers."); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("I have added a number of hardware test functions accessable by either the 'Port Testing' Menu or the buttons found on the right hand side of this"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("waveform display area.  This should help you in confirming this program supports your computer's hardware."); Y=Y+25.0; MovePenTo(BPoint(X,Y));
    
    DrawString("Once you have confirmed that the program works ok on your machine, and also with your input hardware then just choose your interface type"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("using the 'Sampling Type' Menu or the equivalent buttons.  Additionally select the 'Number of Inputs' and 'Sample Timing' buttons then just click"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("the 'Sample & Plot' button."); Y=Y+25.0; MovePenTo(BPoint(X,Y));

    DrawString("Note(1):  I found while testing the GamePort Analog Joystick interface that BeOS defaults to Dual Two(2) Axis Joysticks.  I found it impossible"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("to access all four axis at first.  Also the BeBook states BeOS only supports one joystick per GamePort.  If however I start up Preferences/Joystick"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("and choose a Four(4) Axis Joystick all the inputs will worked ok."); Y=Y+25.0; MovePenTo(BPoint(X,Y));

    DrawString("Note(2):  The direct gameport modes address fixed I/O port addresses, if these modes do not work for you use try using Preference/Devices"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("to find the correct address needed."); Y=Y+25.0; MovePenTo(BPoint(X,Y));

    DrawString("Note(3):  There is no code to test or use the second gameport."); Y=Y+25.0; MovePenTo(BPoint(X,Y));

    DrawString("Note(4):  For the last couple of weeks I have been trying to debug the BJoyStick() of BeOS.  There seems to be a timing problem that at present I"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("can not seem to fix.  My direct code seem to work ok unless the user tries to access the menus at the same time sampling is being done."); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("The sample code in the tests folder does use BJoyStick() and works ok, but I can't understand why.  The only real diffirence I can find is the"); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    DrawString("Pulse() function.  I am adding pulse drive code but have not finished it yet."); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    SetFontSize(12); }

 if (Display == 1001) { // Counting Up.
    MovePenTo(BPoint(100.0,150.0)); SetFontSize(96); DrawString("Counting Up."); SetFontSize(12); }

 if (Display == 1002) { // Counting Down.
    MovePenTo(BPoint(100.0,150.0)); SetFontSize(96); DrawString("Counting Down."); SetFontSize(12); }

 if (Display == 1003) { // // Read the sound card.
    SetFontSize(36); // Nice font size
    MovePenTo(BPoint(100.0,150.0)); sprintf(TextBuffer,"Sound channel 1 reads --> %d ",display_data1); DrawString(TextBuffer);
    MovePenTo(BPoint(100.0,200.0)); sprintf(TextBuffer,"Sound channel 2 reads --> %d ",display_data2); DrawString(TextBuffer);
    SetFontSize(12); } // Restore font size

 if (Display == 1004) { // Read the GamePort/Joystick Buttons directly.
    SetFontSize(12); X=20.0; Y=20.0; MovePenTo(BPoint(X,Y)); // Nice font size, set cursor position.
    port = new ParPort(); port->Open(); // Create a new Parallel Port. Remember to open the port.
    for (int n=0; n<25; n++) {
        int m = port->In(GamePortAddress); sprintf(TextBuffer,"GamePort Registers --> %d        Buttons --> %d", m, m/16);
        DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y)); snooze(Timing); } // Print I/O information. Wait till next valid time to do sampling.
    port->Close(); }

 if (Display == 1005) { // Read the GamePort/Joystick Analog timing directly.
    SetFontSize(12); X=20.0; Y=20.0; MovePenTo(BPoint(X,Y)); // Nice font size, set cursor position.
    port = new ParPort(); port->Open(); // Create a new Parallel Port. Remember to open the port.
    for (int n=0; n<20; n++) {
        SampleCount = 0; ADC_Time = system_time(); port->Out(GamePortAddress,0); while ((SampleCount < 999) & (port->In(GamePortAddress) & 1)) { SampleCount++; } // Wait till flag clears.
        sprintf(TextBuffer,"Timing --> %d        Loops --> %d",(int)(system_time() - ADC_Time),(int)SampleCount);
        DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y)); snooze(Timing); } // Print I/O information. Wait till next valid time to do sampling.
    port->Close(); }

 if (Display == 1006) { // Read the game port info, open the GamePort/Joystick in non-enhanced mode.
    SetFontSize(12); X=20.0; Y=20.0; MovePenTo(BPoint(X,Y)); // Nice font size, set cursor position.
    JoyStick = new BJoystick(); // Create a joystick object.
    Device_Count = JoyStick->CountDevices(); sprintf(TextBuffer,"Number of gameport devices found--> %d ",(int)Device_Count); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    for (int n=0; n<Device_Count; n++) {
        JoyStick->GetDeviceName(n, JoyStick_Name); // Get name of GamePort.
        sprintf(TextBuffer,"Device name of gameport %d --> %s",n,JoyStick_Name); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y)); // Print names of gameport devices.
        JoyStick->Open(JoyStick_Name,false); JoyStick->GetControllerName(&Control_Name); // Open port in unenhanced mode.
        sprintf(TextBuffer,"Controller name of gameport --> %s",Control_Name.String()); DrawString(TextBuffer); Y=Y+25.0; MovePenTo(BPoint(X,Y)); // Print names of gameport controllers.
        JoyStick->Close(); }
    status_t Status = JoyStick->GetDeviceName(0, JoyStick_Name); // Get name of first gameport device.
    if (Status == B_OK) {
       sprintf(TextBuffer,"Opened first game port in enhanced mode. Device name of gameport read --> %s ",JoyStick_Name); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y));
       Status = JoyStick->Open(JoyStick_Name,false); // Open GamePort Object as unenhanced.
       if (Status >= B_OK) { // Positive value means successful open.
          for (int n=0; n<20; n++) {
              JoyStick->Update(); snooze(Timing); sprintf(TextBuffer,"Joystick:  TimeStamp-->%d<--  Horizontal-->%4ld<--  Vertical-->%4ld<--  Button 1-->%d<--  Button 2 -->%d<--",
              (int)JoyStick->timestamp, (long)JoyStick->horizontal, (long)JoyStick->vertical, JoyStick->button1, JoyStick->button2); // Read Joystick status.
              DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y)); } // Print Joystick information. Wait till next valid time to do sampling.
          JoyStick->Close(); // Close GamePort.
       }else{
          DrawString("First joystick on gameport would not open in unenhanced mode."); Y=Y+25.0; MovePenTo(BPoint(X,Y)); } }
    delete JoyStick; SetFontSize(12); } // Delete BJoystick object. Restore font size

 if (Display == 1007) { // Read the game port info, open the GamePort/Joystick in enhanced mode.
    SetFontSize(12); X=20.0; Y=20.0; MovePenTo(BPoint(X,Y)); // Nice font size, set cursor position.
    JoyStick = new BJoystick(); // Create a joystick object.
    Device_Count = JoyStick->CountDevices(); sprintf(TextBuffer,"Number of gameport devices found--> %d ",(int)Device_Count); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y));
    for (int n=0; n<Device_Count; n++) {
        JoyStick->GetDeviceName(n, JoyStick_Name); // Get name of GamePort.
        sprintf(TextBuffer,"Device name of gameport %d --> %s",n,JoyStick_Name); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y)); // Print names of gameport devices.
        JoyStick->Open(JoyStick_Name,true); JoyStick->GetControllerName(&Control_Name); // Open port in enhanced mode.
        sprintf(TextBuffer,"Controller name of gameport --> %s",Control_Name.String()); DrawString(TextBuffer); Y=Y+25.0; MovePenTo(BPoint(X,Y)); // Print names of gameport controllers.
        JoyStick->Close(); }
    status_t Status = JoyStick->GetDeviceName(0, JoyStick_Name); // Get name of first gameport device.
    if (Status == B_OK) {
       sprintf(TextBuffer,"Opened first game port in enhanced mode. Device name of gameport read --> %s ",JoyStick_Name); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y));
       Status = JoyStick->Open(JoyStick_Name,true); // Open GamePort Object and Open.
       if (Status >= B_OK) { // Positive value means successful open.
          Stick_Count = JoyStick->CountSticks(); Hat_Count = JoyStick->CountHats(); Button_Count = JoyStick->CountButtons(); Axis_Count = JoyStick->CountAxes(); 
          sprintf(TextBuffer,"Gameport/JoyStick Sticks--> %d  Hats--> %d  Buttons--> %d   Axis--> %d", (int)Stick_Count, (int)Hat_Count, (int)Button_Count, (int)Axis_Count); DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y));
          if (JoyStick->IsCalibrationEnabled() == true ) { DrawString("Is Calibrated"); }else{ DrawString("Is not in Calibration"); } ; Y=Y+15.0; MovePenTo(BPoint(X,Y));

          // int16 Pot_Values[9]; // same as ? => 
          int16* axes; axes = (int16 *) malloc(sizeof(int16) * Axis_Count); // Create array to recieve axis values.
          for (int n=0; n<20; n++) {
              JoyStick->Update(); snooze(Timing); TimeStamp = JoyStick->timestamp; Button_Values = JoyStick->ButtonValues(); JoyStick->GetAxisValues(axes,0); // Read Joystick status.
              sprintf(TextBuffer,"TimeStamp %d  Joystick Buttons --> %d   Axis(1-4)-->  %4ld   %4ld   %4ld   %4ld",(int)TimeStamp, (int)Button_Values, (long)axes[0], (long)axes[1], (long)axes[2], (long)axes[3]);
              DrawString(TextBuffer); Y=Y+15.0; MovePenTo(BPoint(X,Y)); } // Print Joystick information. Wait till next valid time to do sampling.
          JoyStick->Close(); // Close GamePort.
       }else{
          DrawString("Joystick would not open in enhanced mode."); Y=Y+15.0; MovePenTo(BPoint(X,Y)); } }
    delete JoyStick; SetFontSize(12); } // Delete BJoystick object. Restore font size

 if (Display == 1008) { // Read the parallel port.
    SetFontSize(36); // Nice font size
    MovePenTo(BPoint(100.0,150.0)); sprintf(TextBuffer,"Parallel Port reads --> %d ",display_data1); DrawString(TextBuffer);
    MovePenTo(BPoint(100.0,200.0)); sprintf(TextBuffer,"  Status Port reads --> %d ",display_data2); DrawString(TextBuffer);
    MovePenTo(BPoint(100.0,250.0)); sprintf(TextBuffer," Control Port reads --> %d ",display_data3); DrawString(TextBuffer);
    SetFontSize(12); } // Restore font size

 if (Display == 1009) { // Write pattern to parallel port.
    SetFontSize(48); // Nice font size
    MovePenTo(BPoint(100.0,150.0)); sprintf(TextBuffer,"Writting Data value %d to Port.",display_data1); DrawString(TextBuffer);
    SetFontSize(12); } // Restore font size

 if (Display > 1999) { // Valid to display grid and bull's eye.
    if (GridMode > 0) {
       SetHighColor(gridColor); // Draw grid inside display area. Set pen to grid colour.
       if (GridMode == 1) {
          for (Y=0.0; Y<401.0; Y=Y+20.0) { MovePenTo(BPoint(0.0,Y)); StrokeLine(BPoint(800.0,Y),B_SOLID_HIGH); }
          for (X=0.0; X<801.0; X=X+20.0) { MovePenTo(BPoint(X,0.0)); StrokeLine(BPoint(X,400.0),B_SOLID_HIGH); } }
       if (GridMode == 2) {
          for (Y=0.0; Y<401.0; Y=Y+40.0) { MovePenTo(BPoint(0.0,Y)); StrokeLine(BPoint(800.0,Y),B_SOLID_HIGH); }
          for (X=0.0; X<801.0; X=X+40.0) { MovePenTo(BPoint(X,0.0)); StrokeLine(BPoint(X,400.0),B_SOLID_HIGH); } }
       if (GridMode == 3) {
          for (X=0.0; X<801.0; X=X+20.0) { MovePenTo(BPoint(X,0.0)); StrokeLine(BPoint(X,400.0),B_SOLID_HIGH); } }
       if (GridMode == 4) {
          for (X=0.0; X<801.0; X=X+40.0) { MovePenTo(BPoint(X,0.0)); StrokeLine(BPoint(X,400.0),B_SOLID_HIGH); } }
       if (GridMode == 5) {
          for (Y=0.0; Y<401.0; Y=Y+20.0) {
              for (X=0.0; X<801.0; X=X+20.0) {
                  MovePenTo(BPoint(X-2.0,Y)); StrokeLine(BPoint(X+2.0,Y),B_SOLID_HIGH);
                  MovePenTo(BPoint(X,Y-2.0)); StrokeLine(BPoint(X,Y+2.0),B_SOLID_HIGH); } } }
       if (GridMode == 6) {
          for (Y=0.0; Y<401.0; Y=Y+20.0) {
              for (X=0.0; X<801.0; X=X+10.0) {
                  MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X,Y),B_SOLID_HIGH); } } }
       if (GridMode == 7) {
          for (Y=0.0; Y<401.0; Y=Y+20.0) {
              for (X=0.0; X<801.0; X=X+20.0) {
                  MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X,Y),B_SOLID_HIGH); } } } }

    if (BullsEye > 0) { // Draw bull's eye inside display area.
       SetHighColor(bulleyeColor); // Set pen to bull's eye colour.
       MovePenTo(BPoint(0.0,200.0)); StrokeLine(BPoint(800.0,200.0),B_SOLID_HIGH);
       MovePenTo(BPoint(400.0,0.0)); StrokeLine(BPoint(400.0,400.0),B_SOLID_HIGH);
       if (BullsEye > 1) {
          for (X=0.0; X<801.0; X=X+20.0) {
              MovePenTo(BPoint(X,197.0)); StrokeLine(BPoint(X,203.0),B_SOLID_HIGH); }
          for (Y=0.0; Y<401.0; Y=Y+20.0) {
              MovePenTo(BPoint(397.0,Y)); StrokeLine(BPoint(403.0,Y),B_SOLID_HIGH); } }
       if (BullsEye > 2) {
          for (X=10.0; X<801.0; X=X+20.0) {
              MovePenTo(BPoint(X,199.0)); StrokeLine(BPoint(X,201.0),B_SOLID_HIGH); }
          for (Y=10.0; Y<401.0; Y=Y+20.0) {
              MovePenTo(BPoint(399.0,Y)); StrokeLine(BPoint(401.0,Y),B_SOLID_HIGH); } } }

    DataWindow = (int)(800.0/HorzScale); DataOffset = (int)(((MaxSamples-DataWindow)*HorzOffset)/999); } // Setup Display variables and Plot data.

 if (Display == 2000) { // Plot Analog Data.
    if (InputSize > 0) { // 1 or more analog input 1 byte each.
       int n; X=0.0; SetHighColor(analog1Color); MovePenTo(BPoint(X,((float)(Sig1[DataOffset]-AnalogBasis))*scaling1+offset1)); // Set pen to analog input 1.
       for (n=DataOffset+1; n<DataWindow+DataOffset+1; n++) {
           X=X+HorzScale; StrokeLine(BPoint(X,((float)(Sig1[n]-AnalogBasis))*scaling1+offset1),B_SOLID_HIGH); } } // Plot signal 1.

    if (InputSize > 1) { // 2 or more analog inputs 1 byte each.
       int n; X=0.0; SetHighColor(analog2Color); MovePenTo(BPoint(X,((float)(Sig2[DataOffset]-AnalogBasis))*scaling2+offset2)); // Set pen to analog input 2.
       for (n=DataOffset+1;n<DataWindow+DataOffset+1;n++) {
           X=X+HorzScale; StrokeLine(BPoint(X,((float)(Sig2[n]-AnalogBasis))*scaling2+offset2),B_SOLID_HIGH); } } // Plot signal 2.

    if (InputSize > 2) { // 4 analog inputs 1 byte each.
       int n; X=0.0; SetHighColor(analog3Color); MovePenTo(BPoint(X,((float)(Sig3[DataOffset]-AnalogBasis))*scaling3+offset3)); // Set pen to analog input 3.
       for (n=DataOffset+1;n<DataWindow+DataOffset+1;n++) {
           X=X+HorzScale; StrokeLine(BPoint(X,((float)(Sig3[n]-AnalogBasis))*scaling3+offset3),B_SOLID_HIGH); } // Plot signal 3.
       X=0.0; SetHighColor(analog4Color); MovePenTo(BPoint(X,((float)(Sig4[DataOffset]-AnalogBasis))*scaling4+offset4)); // Set pen to analog input 4.
       for (n=DataOffset+1; n<DataWindow+DataOffset+1; n++) {
           X=X+HorzScale; StrokeLine(BPoint(X,((float)(Sig4[n]-AnalogBasis))*scaling4+offset4),B_SOLID_HIGH); } } } // Plot signal 4.

 if (Display == 2100) { // Plot Digital Data.
    if (InputSize == 1) { // 1 Direct digital inputs, 1 bit each from each byte from the parallel port.
       int n, data1, data2; X=0.0; Y=200.0; SetHighColor(zeroColor); // Set drawing colour
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+200.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH);
       SetHighColor(digitalColor); data2 = Sig1[DataOffset]; // Set drawing colour, Get first data element.
       for (n=DataOffset; n<DataWindow+DataOffset+1; n++) {
           data1 = data2; data2 = Sig1[n+1]; Y=120.0;
           if (Mask[0] & data1) {
              MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH);
              if (!(Mask[0] & data2)) {
                 StrokeLine(BPoint(X+HorzScale,Y+80.0),B_SOLID_HIGH); } }
            else {
               MovePenTo(BPoint(X,Y+80.0)); StrokeLine(BPoint(X+HorzScale,Y+80.0),B_SOLID_HIGH);
               if (Mask[0] & data2) {
                  StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH); } }
            X=X+HorzScale; } }

    if (InputSize == 2) { // 2 Direct digital inputs, 1 bit each from each byte from the parallel port.
       int n, scan, data1, data2; X=0.0; Y=160.0; SetHighColor(zeroColor); // Set drawing colour
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+160.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH);
       SetHighColor(digitalColor); data2 = Sig1[DataOffset]; // Set drawing colour, Get first data element.
       for (n=DataOffset; n<DataWindow+DataOffset+1; n++) {
           data1 = data2; data2 = Sig1[n+1]; Y=80.0;
           for (scan=0; scan<2; scan++) {
               if (Mask[scan] & data1) {
                  MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH);
                  if (!(Mask[scan] & data2)) {
                     StrokeLine(BPoint(X+HorzScale,Y+80.0),B_SOLID_HIGH); } }
               else {
                  MovePenTo(BPoint(X,Y+80.0)); StrokeLine(BPoint(X+HorzScale,Y+80.0),B_SOLID_HIGH);
                  if (Mask[scan] & data2) {
                     StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH); } }
               Y=Y+160.0; }
           X=X+HorzScale; } }

    if (InputSize == 4) { // 4 Direct digital inputs, 1 bit each from each byte from the parallel port.
       int n, scan, data1, data2; X=0.0; Y=80.0; SetHighColor(zeroColor); // Set drawing colour
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+80.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+120.0;
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+80.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH);
       SetHighColor(digitalColor); data2 = Sig1[DataOffset]; // Set drawing colour, Get first data element.
       for (n=DataOffset; n<DataWindow+DataOffset+1; n++) {
           data1 = data2; data2 = Sig1[n+1]; Y=40.0;
           for (scan=0; scan<4; scan++) {
               if (scan == 2) { Y=Y+40.0; } // Avoid center line on grid display
               if (Mask[scan] & data1) {
                  MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH);
                  if (!(Mask[scan] & data2)) {
                     StrokeLine(BPoint(X+HorzScale,Y+40.0),B_SOLID_HIGH); } }
               else {
                  MovePenTo(BPoint(X,Y+40.0)); StrokeLine(BPoint(X+HorzScale,Y+40.0),B_SOLID_HIGH);
                  if (Mask[scan] & data2) {
                     StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH); } }
               Y=Y+80.0; }
           X=X+HorzScale; } }

    if (InputSize == 6) { // 6 Direct digital inputs, 1 bit each from each byte from the parallel port.
       int n, scan, data1, data2; X=0.0; Y=60.0; SetHighColor(zeroColor); // Set drawing colour
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+60.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+60.0;
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+80.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+60.0;
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+60.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH);
       SetHighColor(digitalColor); data2 = Sig1[DataOffset]; // Set drawing colour, Get first data element.
       for (n=DataOffset; n<DataWindow+DataOffset+1; n++) {
           data1 = data2; data2 = Sig1[n+1]; Y=20.0;
           for (scan=0; scan<6; scan++) {
               if (scan == 3) { Y=Y+20.0; } // Avoid center line on grid display
               if (Mask[scan] & data1) {
                  MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH);
                  if (!(Mask[scan] & data2)) {
                     StrokeLine(BPoint(X+HorzScale,Y+40.0),B_SOLID_HIGH); } }
               else {
                  MovePenTo(BPoint(X,Y+40.0)); StrokeLine(BPoint(X+HorzScale,Y+40.0),B_SOLID_HIGH);
                  if (Mask[scan] & data2) {
                     StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH); } }
               Y=Y+60.0; }
           X=X+HorzScale; } }

    if (InputSize == 8) { // 8 Direct digital inputs, 1 bit each from each byte from the parallel port.
       int n, scan, data1, data2; X=0.0; Y=60.0; SetHighColor(zeroColor); // Set drawing colour
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+40.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+40.0;
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+40.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+60.0;
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+40.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+40.0;
       MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH); Y=Y+40.0; MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+800.0,Y),B_SOLID_HIGH);
       SetHighColor(digitalColor); data2 = Sig1[DataOffset]; // Set drawing colour, Get first data element.
       for (n=DataOffset; n<DataWindow+DataOffset+1; n++) {
           data1 = data2; data2 = Sig1[n+1]; Y=40.0;
           for (scan=0; scan<8; scan++) {
               if (scan == 4) { Y=Y+20.0; } // Avoid center line on grid display
               if (Mask[scan] & data1) {
                  MovePenTo(BPoint(X,Y)); StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH);
                  if (!(Mask[scan] & data2)) {
                     StrokeLine(BPoint(X+HorzScale,Y+20.0),B_SOLID_HIGH); } }
               else {
                  MovePenTo(BPoint(X,Y+20.0)); StrokeLine(BPoint(X+HorzScale,Y+20.0),B_SOLID_HIGH);
                  if (Mask[scan] & data2) {
                     StrokeLine(BPoint(X+HorzScale,Y),B_SOLID_HIGH); } }
               Y=Y+40.0; }
           X=X+HorzScale; } } } 

 System_Free = true; } // Free flag to allow Digital_Scope_Application::Pulse() to be used again.

/********************************************************************************************************************************************************************************************************************/
