// Digital_Analog_Scope_0.92 by Earl Colby Pottinger.
// Partly based on code found in the Beos CDROM
// Partly based on instructions found in "Programming the Be Operating System" By Dan Parks Sydow.
// Additional help by Larry Baydak in debugging and coding/commenting style.
// GUI help by M4RCONE@XS4ALL.NL - Thanks.

// #include "Digital_Scope_Includes.h" #include "Digital_Scope_IO_Includes.h" #include "Digital_Scope_Menus.h"
// #include "Digital_Scope_Window.h"   #include "Digital_Scope_View.h"  #include "Digital_Display_View.h"    #include "Digital_Scope_Window.cpp" #include "Digital_Scope_View.cpp" #include "Digital_Display_View.cpp"
// #include "Digital_Colour_Window.h"  #include "Digital_Colour_View.h" #include "Digital_Colour_Window.cpp" #include "Digital_Colour_View.cpp"
// #include "Digital_Scope_World.h"    #include "Digital_Scope_World.cpp"

/********************************************************************************************************************************************************************************************************************/

#include "01.0_Digital_Scope_Includes.h"
#include "01.5_Digital_Scope_IO_Includes.h"
#include "02.0_Digital_Scope_Menus.h"
#include "03.0_Global_Constants_&_Variables.h"
#include "04.0_Global_Headers.h"
#include "05.0_Digital_Scope_View.cpp"
#include "06.0_Digital_Display_View.cpp"
#include "07.0_Digital_Colour_View.cpp"
#include "08.0_Digital_Scope_Window.cpp"
#include "09.0_Digital_Colour_Window.cpp"

/********************************************************************************************************************************************************************************************************************/

// Digital_Scope_World.cpp  The main() function's only real job in a basic BeOS application is to create the BApplication object and run it.
int main(int, char**) {
 Digital_Scope_Application myApplication; myApplication.Run(); return(0); } // Create an Be_app instance, run the app thread, process messages.  Return 0 for no errors.

Digital_Scope_Application::Digital_Scope_Application() : BApplication(APP_SIGNATURE) { // Define 'Digital_Scope_Application' constructor call.
 for (int n=0; n<1098; n++) {
     Sig1[n] = 0; Sig2[n] = 0; Sig3[n] = 0; Sig4[n] = 0; Sig5[n] = 0; Sig6[n] = 0; Sig7[n] = 0; Sig8[n] = 0; }
 if (find_directory (B_USER_SETTINGS_DIRECTORY, &file_path) == B_OK) {
    file_path.Append("D.A.Scope_Settings_0.92"); ref = open(file_path.Path(), O_RDONLY);
    if (ref >= 0) {
       // Debugging options.
       read(ref,(char *)&DeBug,sizeof(DeBug));
       // Last position of display and colour control windows.
       read(ref,(char *)&aWindow1_Rect,sizeof(aWindow1_Rect)); read(ref,(char *)&aWindow2_Rect,sizeof(aWindow2_Rect));
       // General user control variables.
       read(ref,(char *)&TriggerValue, sizeof(TriggerValue));  read(ref,(char *)&TriggerMode,  sizeof(TriggerMode));
       read(ref,(char *)&JoyStickMode, sizeof(JoyStickMode));  read(ref,(char *)&InputSize,    sizeof(InputSize));
       read(ref,(char *)&InputType,    sizeof(InputType));     read(ref,(char *)&ScanMode,     sizeof(ScanMode));
       read(ref,(char *)&BullsEye,     sizeof(BullsEye));      read(ref,(char *)&GridMode,     sizeof(GridMode));
       read(ref,(char *)&Timing,       sizeof(Timing));        read(ref,(char *)&Display,      sizeof(Display)); if (Display < 2000) { Display = 0; } // If no waveform display then revert of Start Screen.
       // Data display scaling and positioning options.
       read(ref,(char *)&scaling1,sizeof(scaling1)); read(ref,(char *)&offset1,sizeof(offset1));
       read(ref,(char *)&scaling2,sizeof(scaling2)); read(ref,(char *)&offset2,sizeof(offset2));
       read(ref,(char *)&scaling3,sizeof(scaling3)); read(ref,(char *)&offset3,sizeof(offset3));
       read(ref,(char *)&scaling4,sizeof(scaling4)); read(ref,(char *)&offset4,sizeof(offset4));
       // User display selected colours. 
       read(ref,(char *)&digitalColor,sizeof(digitalColor)); read(ref,(char *)&displayColor,sizeof(displayColor)); read(ref,(char *)&bulleyeColor,sizeof(bulleyeColor));
       read(ref,(char *)&analog1Color,sizeof(analog1Color)); read(ref,(char *)&analog2Color,sizeof(analog2Color)); read(ref,(char *)&gridColor,   sizeof(gridColor));
       read(ref,(char *)&analog3Color,sizeof(analog3Color)); read(ref,(char *)&analog4Color,sizeof(analog4Color)); read(ref,(char *)&zeroColor,   sizeof(zeroColor)); close(ref);
    }else{
       aWindow1_Rect.Set(20, 20, 980, 760); aWindow2_Rect.Set(100, 100, 500, 200); } } // Set the Screen Bpoints into the rectangle object(aRect) to define a default window.

 aView1_Rect.Set(10, 10, 950, 750); // Set the Window Bpoints into the rectangle object(aRect) to define a view.
 aView2_Rect.Set(20, 20, 820, 420); // Set the Window Bpoints to define a view 801 pixels by 401 pixels.
 aView3_Rect.Set(10, 10, 400, 100); // Set the Window Bpoints to define a view for color control view.

// Create a window and views to display scope.
 aWindow1 = new Digital_Scope_Window(aWindow1_Rect); // Invoke a new dynamically allocated window object by calling the constructor.
 aView1   = new Digital_Scope_View(aView1_Rect, "Scope_View" ) ; // Invoke a new dynamically allocated view object inside the window by calling the constructor. Plus supply a ID name for the view.
 aView2   = new Digital_Display_View(aView2_Rect,"Scope_Display'" ) ; // Invoke a new dynamically allocated view object inside the window by calling the constructor. Plus supply a ID name for the view.
 aView2->SetViewColor(displayColor); // Set Background Colour.
 aWindow1->AddChild(aView1); aView1->AddChild(aView2); aWindow1->Show(); // Add views to window. Redraw window with the views attached.

// Create a colour control window and a view to display colour controls.
 aWindow2 = new Digital_Colour_Window(aWindow2_Rect); // Invoke a new dynamically allocated window object by calling the constructor.
 aView3   = new Digital_Colour_View(aView3_Rect,"Scope_Colour" ) ; // Invoke a new dynamically allocated view object inside the window by calling the constructor. Plus supply a ID name for the view.
 aWindow2->AddChild(aView3); aWindow2->Show(); aWindow2->Minimize(true); // Add view to window. Redraw window with the views attached. Minimize window.
 } // Setup new windows, restore to old positions if possible.

// ::~Digital_Scope_Application
Digital_Scope_Application::~Digital_Scope_Application() {
 if (find_directory (B_USER_SETTINGS_DIRECTORY, &file_path, true) == B_OK) {
    file_path.Append("D.A.Scope_Settings_0.92"); ref = creat(file_path.Path(), 0777);
    if (ref >= 0) {
       // Debugging options.
       write(ref,(char *)&DeBug,sizeof(DeBug));
       // Last position of display and colour control windows.
       write(ref,(char *)&aWindow1_Rect,sizeof(aWindow1_Rect)); write(ref,(char *)&aWindow2_Rect,sizeof(aWindow2_Rect));
       // General user control variables.
       write(ref,(char *)&TriggerValue,sizeof(TriggerValue)); write(ref,(char *)&TriggerMode,sizeof(TriggerMode));
       write(ref,(char *)&JoyStickMode,sizeof(JoyStickMode)); write(ref,(char *)&InputSize,  sizeof(InputSize));
       write(ref,(char *)&InputType,   sizeof(InputType));    write(ref,(char *)&ScanMode,   sizeof(ScanMode));
       write(ref,(char *)&BullsEye,    sizeof(BullsEye));     write(ref,(char *)&GridMode,   sizeof(GridMode));
       write(ref,(char *)&Timing,      sizeof(Timing));       write(ref,(char *)&Display,    sizeof(Display));
       // Data display scaling and positioning options.
       write(ref,(char *)&scaling1,sizeof(scaling1)); write(ref,(char *)&offset1,sizeof(offset1));
       write(ref,(char *)&scaling2,sizeof(scaling2)); write(ref,(char *)&offset2,sizeof(offset2));
       write(ref,(char *)&scaling3,sizeof(scaling3)); write(ref,(char *)&offset3,sizeof(offset3));
       write(ref,(char *)&scaling4,sizeof(scaling4)); write(ref,(char *)&offset4,sizeof(offset4));
       // User display selected colours. 
       write(ref,(char *)&digitalColor,sizeof(digitalColor)); write(ref,(char *)&displayColor,sizeof(displayColor)); write(ref,(char *)&bulleyeColor,sizeof(bulleyeColor));
       write(ref,(char *)&analog1Color,sizeof(analog1Color)); write(ref,(char *)&analog2Color,sizeof(analog2Color)); write(ref,(char *)&gridColor,   sizeof(gridColor));
       write(ref,(char *)&analog3Color,sizeof(analog3Color)); write(ref,(char *)&analog4Color,sizeof(analog4Color)); write(ref,(char *)&zeroColor,   sizeof(zeroColor)); close(ref);
    }else{
       alert = new BAlert("BAlert","Could not save program settings.","OK"); result = alert->Go(); } } }

// ::AboutRequested. Recieved About message.
void Digital_Scope_Application::AboutRequested() { // Displays alert with warning.
 alert = new BAlert("About BAlert","About Digital_Analog_Scope_0.92.\n" "Acts as a digital or analog scope.\n" "Uses :-\n"
 "Analog-Audio inputs of SoundBlaster Cards.\n" "Analog-Joystick inputs of Game Cards.\n" "Analog-Parallel Port interface to ADCs.\n"
 "Digital-Joystick inputs of Games Cards.\n" "Digital-Parallel Port Data Lines 1-8.\n","OK"); result = alert->Go(); }

// ::MessageReceived.  Handle incoming messages.
void Digital_Scope_Application::MessageReceived(BMessage *message) {
 switch(message->what) {
  case B_SAVE_REQUESTED: {
       // BMessage: what = SAVE (0x53415645, or 1396790853)
       //     entry      directory, type='RREF', c=1, size=17, data[0]: device=4, directory=131072, name="home", path="/boot/home"
       //     entry           name, type='CSTR', c=1, size=5, data[0]: "test"
       File_Error = message->FindRef("directory", &file_ref); // Process entry_ref for directory file is save in.
       File_Error = b_entry.SetTo(&file_ref);                 // Transfer into a BEntry structure.
       b_entry.GetPath(&file_path);                           // Bpath object set from BEntry
       File_Error = message->FindString("name", &file_name);  // Process file name separate text string.
       file_path.Append(file_name);                           // append file name to path.       
       File_Error = File_Object.SetTo(file_path.Path(), B_WRITE_ONLY|B_CREATE_FILE|B_ERASE_FILE); // Set BFile object to filter.
       File_Error = File_Object.Write((void *)Sig1, 1026); File_Error = File_Object.Write((void *)Sig2, 1026); // Write file.
       File_Error = File_Object.Write((void *)Sig3, 1026); File_Error = File_Object.Write((void *)Sig4, 1026);
       File_Object.Unset(); aWindow1->Lock(); aView2->Invalidate(); aWindow1->Unlock(); break; } // Close File. Forces a redraw of the data display.

  case COLOUR_SET: {
       aWindow2->Minimize(false); aWindow2->Lock(); aView3->Invalidate(); aWindow2->Unlock(); break; } // Forces a redraw of the colour control window.

  case MENU_COUNT_UP: { // Count up parallel output.
       if (Help) {
          alert = new BAlert("Help","Set Parallel Port to Output. Counts up and outputs to the parallel port from 0 to 255.","OK"); result = alert->Go();
       }else{
          Display = 1001; aWindow1->Lock(); aView2->Invalidate(); aWindow1->Unlock(); // Forces a redraw of the display.
          port = new ParPort(); port->Open();                 // Create a new Parallel Port. Remember to open the port.
          int scan = port->In(PC) & 223; port->Out(PC, scan); // Mask & Write to Control register for output on parallel port.
          for (int n = 0; n<256; n++) {                       // Output range 0-255 to parallel port.
              port->Out(PO, n); snooze(Timing); }             // Output 1 byte to the parallel port. Timing delay
          port->Close(); }                                    // Finished, and to be safe, close ParPort.
       break; }

  case MENU_COUNT_DOWN: { // Count down parallel output
       if (Help) {
          alert = new BAlert("Help","Set Parallel Port to Output. Count down and outputs to the parallel port from 255 to 0.","OK"); result = alert->Go();
       }else{
          Display = 1002; aWindow1->Lock(); aView2->Invalidate(); aWindow1->Unlock(); // Forces a redraw of the display.
          port = new ParPort(); port->Open();                 // Create a new Parallel Port. Remember to open the port.
          int scan = port->In(PC) & 223; port->Out(PC, scan); // Mask & Write to Control register for output on parallel port.
          for (int n = 0; n<256; n++) {                       // Ouput range 255-0 to parallel port.
              port->Out(PO, 255-n); snooze(Timing); }         // Output 1 byte to the parallel port. Timing delay
          port->Close(); }                                    // Finished, and to be safe, close ParPort.
       break; }

  case APP_SLEEP: {
       sleep(1); break; } // Put thread to sleep, one second delay.

  case MENU_PULSE_OFF: {
       Pulse_Sampling_Mode = false; Pulse_Scan_Mode = false; SetPulseRate(0L); aWindow1->Lock(); aView1->Invalidate(); aWindow1->Unlock(); break; } // Sends a pulse message to BApplication to turn off Pulses.

  case MENU_PULSE_0: {
       SetPulseRate(100000L); break; } // Sends a pulse message to BApplication, every .1 seconds.

  case MENU_PULSE_1: {
       SetPulseRate(1000000L); break; } // Sends a pulse message to BApplication, every 1 seconds.

  case MENU_PULSE_10: {
       SetPulseRate(10000000L); break; } // Sends a pulse message to BApplication, every 10 seconds.

  case MENU_PULSE_100: {
       SetPulseRate(100000000L); break; } // Sends a pulse message to BApplication, every 100 seconds.

  case APP_SCAN_PLOT: { // Collect data to Display
       System_Free = false;
       if (InputSize == 0) {
          alert = new BAlert("BAlert","Number of Inputs not selected.","OK"); result = alert->Go(); }

       /*************************************************************************************************/

       if (InputType == 100) { // Read in Parallel Port Digital lines.
          if (InputSize > 0) { // Read one(1) or more lines in.
             if (DeBug && 32 ) {
                alert = new BAlert("BAlert","Read in Parallel Port Digital lines.","OK"); result = alert->Go(); }
             port = new ParPort(); port->Open(); // Create new Parallel Port, open the port.
             port->Out(PC, port->In(PC)|32);     // Mask & Write Control register for input.
             port->Out(PO, 255); TimeBase = system_time(); // Set all outputs lines high. Get BaseTime to time sampling.
             for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
                 Sig1[n] = port->In(PO); // Store all 8 Bits.
                 if (Timing) { // Wait till next valid time slice to do sampling.
                    TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
             port->Close(); } } // Finished, close ParPort.  Forces a redraw of the display.

       /*************************************************************************************************/
       
       if (InputType == 110) { // Read in Game Port Digital lines (Buttons). 
          if (JoyStickMode == 1) { // Read Joystick I/O port in direct mode.
             if (InputSize > 0) { // Read one(1) or more lines in.
                if (DeBug && 32 ) {
                   alert = new BAlert("BAlert","Directly read in Game Port's Digital Buttons lines.","OK"); result = alert->Go(); }
                if (InputSize > 4) {
                   InputSize = 4; alert = new BAlert("BAlert","Only four(4) inputs allowed in 'Direct' mode.  Resizing.","OK"); result = alert->Go(); }
                port = new ParPort(); port->Open(); TimeBase = system_time(); // Create a new I/O Port. Remember to open the port. Get BaseTime to time sampling.
                for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
                    Sig1[n] = port->In(GamePortAddress); // Read four buttons on the first joystick.
                    if (Timing) { // Wait till next valid time slice to do sampling.
                       TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
                port->Close(); // Finished, close ParPort.
                for (int n=0; n<MaxSamples; n++) { // Adjust data buffer values to plotable range. Setup four buttons on the first joystick.
                    Sig1[n] = Sig1[n]/16; } } } }

       /*************************************************************************************************/

       if (InputType == 110) { // Read in Game Port Digital lines (Buttons). 
          if (JoyStickMode == 2) { // Open BJoyStick() in 'Basic' mode.
             if (InputSize > 0) { // Read one(1) or more lines in.
                if (DeBug && 32 ) {
                   alert = new BAlert("BAlert","Reading using the 'Basic' mode Game Port's Digital Buttons lines.","OK"); result = alert->Go(); }
                if (InputSize > 2) {
                   InputSize = 2; alert = new BAlert("BAlert","Only two(2) inputs allowed in 'Basic' mode.  Resizing.","OK"); result = alert->Go(); }
                JoyStick = new BJoystick(); Device_Count = JoyStick->CountDevices(); // Create a joystick object.  Count number of Game Ports available.
                if (Device_Count == 0) { 
                   alert = new BAlert("BAlert","No GamePorts found.","OK"); result = alert->Go(); }
                JoyStick->GetDeviceName(0, JoyStick_Name); JoyStick->Open(JoyStick_Name,false); // Get name of first gameport device. Open GamePort Object as unenhanced.
                TimeBase = system_time(); // Get BaseTime to time sampling.
                for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
                    JoyStick->Update(); Sig1[n] = 0; // Read Joystick status. Clear buffer.
                    if (JoyStick->button1 == true) {
                       Sig1[n] = 1; }
                    if (JoyStick->button2 == true) {
                       Sig1[n] = Sig1[n] + 2; }
                    if (Timing) { // Wait till next valid time slice to do sampling.
                       TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } } 
                JoyStick->Close(); delete JoyStick; } } } // Close GamePort. Delete BJoystick object. Forces a redraw of the display.

       /*************************************************************************************************/

       if (InputType == 110) { // Read in Game Port Digital lines (Buttons). 
          if (JoyStickMode == 3) { // Open BJoyStick() in 'Enhanced' mode.
             if (InputSize > 0) { // Read one(1) or more lines in.
                if (DeBug && 32 ) {
                   alert = new BAlert("BAlert","Reading using the 'Enhanced' mode Game Port's Digital Buttons lines.","OK"); result = alert->Go(); }
                JoyStick = new BJoystick(); Device_Count = JoyStick->CountDevices(); // Create a joystick object. Count number of Game Ports available.
             if (Device_Count == 0) {
                alert = new BAlert("BAlert","No GamePorts found.","OK"); result = alert->Go(); }
             JoyStick->GetDeviceName(0, JoyStick_Name); JoyStick->Open(JoyStick_Name,true); // Get name of first gameport device.  Open port in Enhanced mode.
             for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
                 JoyStick->Update(); Sig1[n] = JoyStick->ButtonValues(); // Read Joystick status. Store value of buttons.
                 if (Timing) { // Wait till next valid time slice to do sampling.
                    TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
          JoyStick->Close(); delete JoyStick; } } } // Close GamePort. Delete BJoystick object. Forces a redraw of the display.

       /*************************************************************************************************/

       if (InputType == 120) { // Read in Game Port Analog lines in.
          if (JoyStickMode == 1) { // Read Joystick I/O port in direct mode.
             if (InputSize > 0) { // Read 1-4 Joystick Analog lines.
                if (DeBug && 32 ) {
                   alert = new BAlert("BAlert","Directly read in 4 Game Port's Joystick Analog timing lines.","OK"); result = alert->Go(); }
                if (InputSize > 4) {
                   InputSize = 4; alert = new BAlert("BAlert","Only four(4) inputs allowed in 'Direct' mode.  Resizing.","OK"); result = alert->Go(); }
                port = new ParPort(); port->Open(); TimeBase = system_time(); // Create a new Parallel Port. Remember to open the port. Get BaseTime to time sampling.
                bool flag1, flag2, flag3, flag4; int data, flags; // Create flags.
                for (int n=0; n<MaxSamples; n++) {  // Fill data buffers.
                    flag1 = true; flag2 = true; flag3 = true; flag4 = true; flags = 0; // Flag buffers not valid yet.
                    port->Out(GamePortAddress,0); ADC_Time = system_time(); // Start timers.  Record start time. 
                    while (flags < InputSize) { // Wait till all flags clears.
                          data = port->In(GamePortAddress); WaitTime = system_time() - ADC_Time; // Read state of all four timers.
                          if (flag1) { //   Read time to do charging on the first  analog joystick input.
                             if ((data & 1) == 0) {
                                Sig1[n] = WaitTime; flag1 = false; flags++; } }
                          if (flag2) { //   Read time to do charging on the second analog joystick input.
                             if ((data & 2) == 0) {
                                Sig2[n] = WaitTime; flag2 = false; flags++; } }
                          if (flag3) { //   Read time to do charging on the third  analog joystick input.
                             if ((data & 4) == 0) {
                                Sig3[n] = WaitTime; flag3 = false; flags++; } }
                          if (flag4) { // Read time to do charging on the fourth analog joystick input.
                             if ((data & 8) == 0) {
                                Sig4[n] = WaitTime; flag4 = false; flags++; } } }
                    if (Timing) { // Wait till next valid time slice to do sampling.
                       TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
                port->Close(); } } } // Finished, close ParPort.

       /*************************************************************************************************/

       if (InputType == 120) { // Read in Game Port Analog lines in.
          if (JoyStickMode == 2) { // Open BJoyStick() in 'Basic' mode
             if (InputSize > 0) { // Read 1 or 2 Joystick Analog lines.
                if (DeBug && 32 ) {
                   alert = new BAlert("BAlert","Reading using the 'Basic' mode Game Port's Analog line.","OK"); result = alert->Go(); }
                if (InputSize > 2) {
                   InputSize = 2; alert = new BAlert("BAlert","Only two(2) inputs allowed in 'Basic' mode.  Resizing.","OK"); result = alert->Go(); }
                JoyStick = new BJoystick(); Device_Count = JoyStick->CountDevices(); // Create a joystick object.
                if (Device_Count == 0) {
                   alert = new BAlert("BAlert","No GamePorts found.","OK"); result = alert->Go(); }
                JoyStick->GetDeviceName(0, JoyStick_Name); JoyStick->Open(JoyStick_Name,false); // Get name of first gameport device. Open GamePort Object as unenhanced.
                TimeBase = system_time(); // Get BaseTime to time sampling.
                for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
                    JoyStick->Update(); Sig1[n] = JoyStick->horizontal; // Read Joystick status. Read first line.
                    if (InputSize == 2) {
                       Sig2[n] = JoyStick->vertical; }
                    if (Timing) { // Wait till next valid time slice to do sampling.
                       TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
                JoyStick->Close(); delete JoyStick; } } } // Close GamePort. Delete BJoystick object.

       /*************************************************************************************************/

       if (InputType == 120) { // Read in Game Port Analog lines in.
          if (JoyStickMode == 3) { // Open BJoyStick() in 'Enhanced' mode
             if (InputSize > 0) { // Read 1-4 Joystick Analog line.
                if (DeBug && 32 ) {
                   alert = new BAlert("BAlert","Reading using the 'Enhanced' mode Game Port's Analog line.","OK"); result = alert->Go(); }
                if (InputSize > 4) {
                   InputSize = 4; alert = new BAlert("BAlert","Program supports only four(4) input Buffers for Analog signals.  Resizing.","OK"); result = alert->Go(); }
                JoyStick = new BJoystick(); Device_Count = JoyStick->CountDevices(); // Create a joystick object.
                if (Device_Count == 0) {
                   alert = new BAlert("BAlert","No GamePorts found.","OK"); result = alert->Go(); }
                JoyStick->GetDeviceName(0, JoyStick_Name); JoyStick->Open(JoyStick_Name,true); // Get name of first gameport device. Open GamePort Object as unenhanced.
                Axis_Count = JoyStick->CountAxes();
                if (InputSize > Axis_Count ) {
                   InputSize = Axis_Count; alert = new BAlert("BAlert","Not enought analog inputs found.  Resizing.","OK"); result = alert->Go(); }
                // int16 Pot_Values[9]; // same as ? => 
                int16* axes; axes = (int16 *) malloc(sizeof(int16) * Axis_Count); // Create array to recieve axis values.
                TimeBase = system_time(); // Get BaseTime to time sampling.
                for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
                    JoyStick->Update(); JoyStick->GetAxisValues(axes,0); Sig1[n] = axes[0]; // Read Joystick status. Read analog values.
                    if (InputSize > 1) {
                       Sig2[n] = axes[1];
                       if (InputSize > 2) {
                          Sig3[n] = axes[2]; Sig4[n] = axes[3]; } }
                    if (Timing) { // Wait till next valid time slice to do sampling.
                       TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
                JoyStick->Close(); delete JoyStick; } } } // Close GamePort. Delete BJoystick object.

       /*************************************************************************************************/

       if (InputType == 130) { // Read 1-2 Sound Card Audio lines in.
          alert = new BAlert("BAlert","SoundBlaster audio card analog input code not working yet.","OK"); result = alert->Go(); }

       /*************************************************************************************************/

      if ((InputType == 140) | // 8 Bit LED ADC input.
          (InputType == 160) | // 4 Bit Flash ADC input.
          (InputType == 180)){ // Single 8 Bit Flash ADC input.
         port = new ParPort(); port->Open(); int data = port->In(PC)&240|32; // Create new Parallel Port, Open the port. Get Control register. Mask out Analog controls, set for input.
         port->Out(PC, data | Gate1); TimeBase = system_time(); // Setup for Signal 1. Sets Pin 1 high, Analog gate 1. Get BaseTime to time sampling.

         for (int n=0; n<MaxSamples; n++) { // Fill data buffers.
             if (InputSize == 1) { // Single Sampling, 8 Bit LED ADC/4 Bit Flash ADC inputs.
                Sig1[n] = port->In(PO); // Sample in.
             }else{ // Dual Sampling, 8 Bit LED ADC inputs.
                port->Out(PC, data | Gate1); Sig1[n] = port->In(PO); // Mask and Write for Signal 1. Set Pin 1 high,  Analog gate 1. Sample in.
                port->Out(PC, data | Gate2); Sig2[n] = port->In(PO); // Mask and Write for Signal 2. Set Pin 14 high, Analog gate 2. Sample in.
                if (InputSize == 4) { // Quad Sampling, 8 Bit LED ADC inputs.
                   port->Out(PC, data | Gate3); Sig3[n] = port->In(PO); // Mask and Write for Signal 3. Set Pin 16 high, Analog gate 3. Sample in.
                   port->Out(PC, data | Gate4); Sig4[n] = port->In(PO); } } // Mask and Write for Signal 4. Set Pin 17 high, Analog gate 4. Sample in.
             if (Timing) { // Wait till next valid time slice to do sampling.
                TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }

          if (InputType == 140) {
             for (int n=0; n<MaxSamples; n++) { // Convert data from 8 Bit LED ADC in buffer.
                 Sig1[n] = LED_8_ADC[Sig1[n]]; 
                 if (InputSize > 1) {
                    Sig2[n] = LED_8_ADC[Sig2[n]];
                    if (InputSize > 2) {
                       Sig3[n] = LED_8_ADC[Sig3[n]]; Sig4[n] = LED_8_ADC[Sig4[n]]; } } } } // Convert input format.

          if (InputType == 160) { // Single 4 Bit Flash ADC input.
             for (int n=0; n<MaxSamples; n++) { // Convert data from 4 Bit Flash ADC in buffer.
                 Sig1[n] = LOWER_4_FLASH[Sig1[n]];
                 if (InputSize > 1) {
                    Sig2[n] = LOWER_4_FLASH[Sig2[n]]; 
                    if (InputSize > 2) {
                       Sig3[n] = LOWER_4_FLASH[Sig3[n]]; Sig4[n] = LOWER_4_FLASH[Sig4[n]]; } } } } // Convert Flash ADC input.

         port->Close(); } // Finished, close ParPort.

       /*************************************************************************************************/

      if (InputType == 150) { // 10 Bit LED ADC input.
         port = new ParPort(); port->Open(); int data1 = port->In(PC)&240|32; // Create new Parallel Port, Open the port. Get Control register. Mask out Analog controls, set for input.
         port->Out(PC, data1 | Gate1); TimeBase = system_time(); // Setup for Signal 1. Sets Pin 1 high, Analog gate 1. Get BaseTime to time sampling.

         for (int n=0; n<MaxSamples; n++) { // Fill data buffers.
             if (InputSize == 1) {// Single Sampling 10 Bit LED ADC input.
                Sig1[n] = port->In(PO); Sig5[n] = port->In(PS); // Stores lower 8 bits of a 10 LEDs BAR ADC on pins 2-9 and upper 2 bits on pins 10 & 12.
             }else{ // Dual Sampling 10 Bit LED ADC inputs.
               port->Out(PC, data1 | Gate1); Sig1[n] = port->In(PO); Sig5[n] = port->In(PS); // Mask and Write for Signal 1. Set Pin 1 high, Analog gate 1.  Stores lower 8 bits of a 10 LEDs BAR ADC on pins 2-9 and upper 2 bits on pins 10 & 12.
               port->Out(PC, data1 | Gate2); Sig2[n] = port->In(PO); Sig6[n] = port->In(PS); // Mask and Write for Signal 2. Set Pin 14 high, Analog gate 2. Stores lower 8 bits of a 10 LEDs BAR ADC on pins 2-9. Store upper 2 bits on pins 10 & 12.
               if (InputSize == 4) { // Quad Sampling 10 Bit LED ADC inputs.
                  port->Out(PC, data1 | Gate3); Sig3[n] = port->In(PO); Sig7[n] = port->In(PS); // Mask and Write for Signal 3. Set Pin 16 high, Analog gate 3. Stores lower 8 bits of a 10 LEDs BAR ADC on pins 2-9. Store upper 2 bits on pins 10 & 12.
                  port->Out(PC, data1 | Gate4); Sig4[n] = port->In(PO); Sig8[n] = port->In(PS); } }// Mask and Write for Signal 4. Set Pin 17 high, Analog gate 4. Stores lower 8 bits of a 10 LEDs BAR ADC on pins 2-9. Store upper 2 bits on pins 10 & 12.
               if (Timing) { // Wait till next valid time slice to do sampling.
                  TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
            for (int n=0; n<MaxSamples; n++) { // Convert data buffers.
                Sig1[n] = LED_10_ADC[Sig1[n]|((Sig5[n]*8)&640)];
                if (InputSize > 1) {
                   Sig2[n] = LED_10_ADC[Sig2[n]|((Sig6[n]*8)&640)];
                   if (InputSize > 2) {
                      Sig3[n] = LED_10_ADC[Sig3[n]|((Sig7[n]*8)&640)]; Sig4[n] = LED_10_ADC[Sig4[n]|((Sig8[n]*8)&640)]; }}} // Convert input format.
            port->Close(); } // Finished, close ParPort.

       /*************************************************************************************************/

      if (InputType == 170) { // Dual 4 Bit Flash ADC input.
         port = new ParPort(); port->Open(); int data1 = port->In(PC)&240|32; // Create new Parallel Port, Open the port. Get Control register. Mask out Analog controls, set for input.
         port->Out(PC, data1 | Gate12); TimeBase = system_time(); // Setup for Signals 1,2. Set Pins 1 & 14 high, Analog gates 1 & 2. Get BaseTime to time sampling.

         for (int n=0; n<MaxSamples; n++) { // Fill data buffer.
             if (InputSize < 3) { // Single or Dual Sampling, Dual 4 Bit Flash ADC inputs.
                Sig1[n] = port->In(PO);          // Sample Flash ADC inputs.
             }else{ // Quad Sampling, Dual 4 Bit Flash ADC input.
                port->Out(PC, data1 | Gate12); Sig1[n] = port->In(PO); // Mask and Write for Signals 1,2. Set Pins 1 & 14 high, Analog gates 1 & 2.  Sample Flash ADC inputs.
                port->Out(PC, data1 | Gate34); Sig3[n] = port->In(PO); // Mask and Write for Signals 3,4. Set Pins 16 & 17 high, Analog gates 3 & 4. Sample Flash ADC inputs.
                if (Timing) { // Wait till next valid time slice to do sampling.
                   TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } } }
            for (int n=0; n<MaxSamples; n++) { // Convert and fill data buffers.
                if (InputSize == 1) {
                   Sig1[n] = LOWER_4_FLASH[Sig1[n]];  // Convert Flash ADC input.
                }else{
                   Sig2[n] = UPPER_4_FLASH[Sig1[n]]; Sig1[n] = LOWER_4_FLASH[Sig1[n]]; // Convert Flash ADC input.
                   if (InputSize > 2) {
                      Sig4[n] = UPPER_4_FLASH[Sig3[n]]; Sig3[n] = LOWER_4_FLASH[Sig3[n]]; }}} // Convert Flash ADC input.
            port->Close(); } // Finished, close ParPort.

       /*************************************************************************************************/

     // Comparor FeedBack on pin 10, 12, 13, 15. Signal High if ADC > Signal.
      if (InputType == 190) { // Scanned analog input.
         port = new ParPort(); port->Open(); port->Out(PC, port->In(PC) & 223); // Create new Parallel Port, open the port. Mask & Write to Control register for output.
         TimeBase = system_time(); // Get BaseTime to time sampling.
         if (InputSize > 0) { // 1-4 scanned analog inputs, 1 byte from the parallel port to DAC.
            for (int n=0; n<MaxSamples; n++) { // Fill data buffers.
               bool flag1=true, flag2=true, flag3=true, flag4=true; int flags=0, scan=0, data; // Flag buffers not valid yet.
               Sig1[n] = 255; Sig2[n] = 255; Sig3[n] = 255; Sig4[n] = 255; // Handle overflow.
               while (flags <InputSize) { // Test range of values.
                     port->Out(PO, scan); data = port->In(PS); // Output test value. Read in comparor flags.
                     if (flag1) { // If buffer not already set, test if scan value is greater than Signal 1. If yes, set buffer & flag.
                        if (data & OpAmp1) {
                           Sig1[n] = scan; flag1 = false; flags++; } }
                     if (flag2) { // If buffer not already set, test if scan value is greater than Signal 2. If yes, set buffer & flag.
                        if (data & OpAmp2) {
                           Sig2[n] = scan; flag2 = false; flags++; } }
                     if (flag3) { // If buffer not already set, test if scan value is greater than Signal 3. If yes, set buffer & flag.
                        if (data & OpAmp3) {
                           Sig3[n] = scan; flag3 = false; flags++; } }
                     if (flag4) { // If buffer not already set, test if scan value is greater than Signal 4. If yes, set buffer & flag.
                        if (data & OpAmp4) {
                           Sig4[n] = scan; flag4 = false; flags++; } }
                     scan++; }
               if (Timing) {
                  TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } } }// Wait till next valid time slice to do sampling.
         port->Close(); } // Finished, close ParPort. Forces a redraw of the display.

       /*************************************************************************************************/

      // Comparor FeedBack on pin 10, 12, 13, 15. Signal High if ADC > Signal x.
      if (InputType == 200) { // 1 traced analog input, 1 byte from the parallel port to DAC.
         port = new ParPort(); port->Open(); port->Out(PC, port->In(PC) & 223); // Create new Parallel Port, open the port. Mask & Write to Control register for output.
         TimeBase = system_time(); // Get BaseTime to time sampling.
         int data1 = Sig1[MaxSamples-1]; int data2 = Sig2[MaxSamples-1]; int data3 = Sig3[MaxSamples-1]; int data4 = Sig4[MaxSamples-1]; // Get last values of Signals 1-4.
         for (int n=0; n<MaxSamples; n++) {  // Fill data buffer.
             if (InputSize > 0) {
                port->Out(PO, data1); // Get last value of Signal 1. Output test value.
                while ((data1>0)   & ((port->In(PS) & OpAmp1) != 0)) { // While ADC is greater than signal, decrease ADC value and loop.
                      data1--; port->Out(PO, data1); }
                while ((data1<255) & ((port->In(PS) & OpAmp1) == 0)) { // While ADC is less than signal, increase ADC value and loop.
                      data1++; port->Out(PO, data1); }
                Sig1[n] = data1; // Store Signal 1.
                if (InputSize > 1) {
                   port->Out(PO, data2); // Get last value of Signal 2. Output test value.
                   while ((data2>0)   & ((port->In(PS) & OpAmp2) != 0)) { // While ADC is greater than signal, decrease ADC value and loop.
                         data2--; port->Out(PO, data2); }
                   while ((data2<255) & ((port->In(PS) & OpAmp2) == 0)) { // While ADC is less than signal, increase ADC value and loop.
                         data2++; port->Out(PO, data2); }
                   Sig2[n] = data2; // Store Signals 2.
                   if (InputSize > 2) {
                      port->Out(PO, data3); // Get last value of Signal 3. Output test value.
                      while ((data3>0)   & ((port->In(PS) & OpAmp3) != 0)) { // While ADC is greater than signal, decrease ADC value and loop.
                            data3--; port->Out(PO, data3); }
                      while ((data3<255) & ((port->In(PS) & OpAmp3) == 0)) { // While ADC is less than signal, increase ADC value and loop.
                            data3++; port->Out(PO, data3); }
                      port->Out(PO, data4); // Get last value of Signal 4. Output test value.
                      while ((data4>0)   & ((port->In(PS) & OpAmp4) != 0)) { // While ADC is greater than signal, decrease ADC value and loop.
                            data4--; port->Out(PO, data4); }
                      while ((data4<255) & ((port->In(PS) & OpAmp4) == 0)) { // While ADC is less than signal, increase ADC value and loop.
                            data4++; port->Out(PO, data4); }
                      Sig3[n] = data3; Sig4[n] = data4; } } } // Store Signals 3,4.
             if (Timing) { // Wait till next valid time slice to do sampling.
                TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } }
         port->Close(); } // Finished, close ParPort.

       /****************************************************************************************/

      // Comparor FeedBack on pin 10, 12, 13, 15. Signal High if ADC > Signal x.
      if (InputType == 210) { // 1 traced analog input, 1 byte from the parallel port to DAC.
         port = new ParPort(); port->Open(); port->Out(PC, port->In(PC) & 223); // Create new Parallel Port, open the port. Mask & Write to Control register for output.
         TimeBase = system_time(); // Get BaseTime to time sampling.
         int data1 = Sig1[MaxSamples-1]; int data2 = Sig2[MaxSamples-1]; int data3 = Sig3[MaxSamples-1]; int data4 = Sig4[MaxSamples-1]; // Get last values of Signals 1-4.
         for (int n=0; n<MaxSamples; n++) {  // Fill data buffer.
             if (InputSize > 0) {
                port->Out(PO, data1); // Get last value of Signal 1. Output test value.
                if ((data1>0)   & ((port->In(PS) & OpAmp1) != 0)) { data1--; port->Out(PO, data1); } // While ADC is greater than signal, decrease ADC value and loop.
                if ((data1<255) & ((port->In(PS) & OpAmp1) == 0)) { data1++; port->Out(PO, data1); } // While ADC is less than signal, increase ADC value and loop.
                Sig1[n] = data1; // Store Signal 1.
                if (InputSize > 1) {
                   port->Out(PO, data2); // Get last value of Signal 2. Output test value.
                   if ((data2>0)   & ((port->In(PS) & OpAmp2) != 0)) { data2--; port->Out(PO, data2); } // While ADC is greater than signal, decrease ADC value and loop.
                   if ((data2<255) & ((port->In(PS) & OpAmp2) == 0)) { data2++; port->Out(PO, data2); } // While ADC is less than signal, increase ADC value and loop.
                   Sig2[n] = data2; // Store Signals 2.
                   if (InputSize > 2) {
                      port->Out(PO, data3); // Get last value of Signal 3. Output test value.
                      if ((data3>0)   & ((port->In(PS) & OpAmp3) != 0)) { data3--; port->Out(PO, data3); } // While ADC is greater than signal, decrease ADC value and loop.
                      if ((data3<255) & ((port->In(PS) & OpAmp3) == 0)) { data3++; port->Out(PO, data3); } // While ADC is less than signal, increase ADC value and loop.
                      port->Out(PO, data4); // Get last value of Signal 4. Output test value.
                      if ((data4>0)   & ((port->In(PS) & OpAmp4) != 0)) { data4--; port->Out(PO, data4); } // While ADC is greater than signal, decrease ADC value and loop.
                      if ((data4<255) & ((port->In(PS) & OpAmp4) == 0)) { data4++; port->Out(PO, data4); } // While ADC is less than signal, increase ADC value and loop.
                      Sig3[n] = data3; Sig4[n] = data4; } } } // Store Signals 3,4.
             if (Timing) { TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } } // Wait till next valid time slice to do sampling.
         port->Close(); } // Finished, close ParPort.


       /****************************************************************************************/

      // Comparor FeedBack on pin 10, 12, 13, 15. Signal High if ADC > Signal x.
      if (InputType == 220) { // 1 scanned analog input, 1 byte from the parallel port to DAC.
         port = new ParPort(); port->Open(); port->Out(PC, port->In(PC) & 223); // Create new Parallel Port, open the port. Mask & Write to Control register for output.
         TimeBase = system_time(); // Get BaseTime to time sampling.
         for (int n=0; n<MaxSamples; n++) {  // Fill data buffer.
         int data1, data2, data3, data4, scan; // Get last values of Signals 1-4.

             port->Out(PO, 128); scan = port->In(PS);
             if (InputSize > 0) {
                if (scan & OpAmp1) { data1 = 0; }else{ data1 = 128; }
                if (InputSize > 1) {
                   if (scan & OpAmp2) { data2 = 0; }else{ data2 = 128; }
                   if (InputSize > 2) {
                      if (scan & OpAmp3) { data3 = 0; }else{ data3 = 128; }
                      if (scan & OpAmp4) { data4 = 0; }else{ data4 = 128; } } } }

             if (InputSize > 0) {
                port->Out(PO, 64+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 + 64; }
                port->Out(PO, 32+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 + 32; }
                port->Out(PO, 16+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 + 16; }
                port->Out(PO,  8+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 +  8; }
                port->Out(PO,  4+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 +  4; }
                port->Out(PO,  2+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 +  2; }
                port->Out(PO,  1+data1); if (port->In(PS) & OpAmp1) { }else{ data1 = data1 +  1; }
                Sig1[n] = data1; // Store Signal 1.
                if (InputSize > 1) {
                   port->Out(PO, 64+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 + 64; }
                   port->Out(PO, 32+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 + 32; }
                   port->Out(PO, 16+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 + 16; }
                   port->Out(PO,  8+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 +  8; }
                   port->Out(PO,  4+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 +  4; }
                   port->Out(PO,  2+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 +  2; }
                   port->Out(PO,  1+data2); if (port->In(PS) & OpAmp2) { }else{ data2 = data2 +  1; }
                   Sig2[n] = data2; // Store Signal 2.
                   if (InputSize > 2) {
                      port->Out(PO, 64+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 + 64; }
                      port->Out(PO, 32+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 + 32; }
                      port->Out(PO, 16+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 + 16; }
                      port->Out(PO,  8+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 +  8; }
                      port->Out(PO,  4+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 +  4; }
                      port->Out(PO,  2+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 +  2; }
                      port->Out(PO,  1+data3); if (port->In(PS) & OpAmp3) { }else{ data3 = data3 +  1; }
                      port->Out(PO, 64+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 + 64; }
                      port->Out(PO, 32+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 + 32; }
                      port->Out(PO, 16+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 + 16; }
                      port->Out(PO,  8+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 +  8; }
                      port->Out(PO,  4+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 +  4; }
                      port->Out(PO,  2+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 +  2; }
                      port->Out(PO,  1+data4); if (port->In(PS) & OpAmp4) { }else{ data4 = data4 +  1; }
                      Sig3[n] = data3; Sig4[n] = data4; } } } // Store Signals 3,4.
             if (Timing) { TimeBase = TimeBase + Timing; snooze_until(TimeBase, B_SYSTEM_TIMEBASE); } } // Wait till next valid time slice to do sampling.
         port->Close(); } // Finished, close ParPort. Forces a redraw of the display.

       /****************************************************************************************/
       
       /*************************************************************************************************/

       aWindow1->Lock(); aView2->Invalidate(); aWindow1->Unlock(); break; } // Forces a redraw of the display.// End of ScanPlot.

       /*************************************************************************************************/

       

  default: { BApplication::MessageReceived(message); break; } } } // End of messages received.

// ::RefsReceived.  Handle a refs received message. The message specifies where to get it (see BFilePanel).
void Digital_Scope_Application::RefsReceived(BMessage *message) {
 if (DeBug && 1) { alert = new BAlert("BAlert","Digital_Scope_Application::RefsReceived.","OK"); result = alert->Go(); }
 File_Error = message->FindRef("refs", &file_ref);
 if (File_Error == B_NO_ERROR) {
    File_Error = File_Object.SetTo(&file_ref, B_READ_ONLY); // Set BFile object to a file, ReadOnly protects from changes.
    File_Error = File_Object.GetSize(&File_Size);           // Get size of file.
    Bytes_Read = File_Object.Read((void *)Sig1, 1026); Bytes_Read = File_Object.Read((void *)Sig2, 1026); // Read file into buffers for display.
    Bytes_Read = File_Object.Read((void *)Sig3, 1026); Bytes_Read = File_Object.Read((void *)Sig4, 1026); // For up to 4 Analog signals.
    File_Object.Unset(); aWindow1->Lock(); aView2->Invalidate(); aWindow1->Unlock(); // Close File. Forces a redraw of the data display.
 }else{
    alert = new BAlert("BAlert","Could not read waveform data.","OK"); result = alert->Go(); } }

// ::ReadyToRun.  A good place to set up windows, etc., just before your application is about to Run().
void Digital_Scope_Application::ReadyToRun() {
 if (DeBug & 8) { alert = new BAlert("BAlert","Digital_Scope_Application::ReadyToRun.","OK"); result = alert->Go(); }
 LED_8_ADC[255]   = 0; LED_8_ADC[254]  = 32; LED_8_ADC[253]  = 64; LED_8_ADC[251]  = 96; LED_8_ADC[247] = 128;
 LED_8_ADC[239] = 160; LED_8_ADC[223] = 192; LED_8_ADC[191] = 224; LED_8_ADC[127] = 255;

 LED_10_ADC[1023] = 0;  LED_10_ADC[1022] = 26; LED_10_ADC[1021] = 51; LED_10_ADC[1019] = 77; LED_10_ADC[1015] = 102; LED_10_ADC[1007] = 128;
 LED_10_ADC[991] = 153; LED_10_ADC[959] = 179; LED_10_ADC[895] = 204; LED_10_ADC[767] = 230; LED_10_ADC[511]  = 255;

 for (int n=0; n<256; n++) { LOWER_4_FLASH[n] = 17 * (n & 15); UPPER_4_FLASH[n] = 17 * ((n & 240) / 16); } } // Fill convertion arrays.

// ::Pulse.  Provides a "heartbeat" for your application; a good place to blink cursors, etc.
void Digital_Scope_Application::Pulse() {
 if (System_Free == true) {
    if (DeBug && 8) { alert = new BAlert("BAlert","System is free. Pulse call to refresh display.","OK"); result = alert->Go(); }
    if (Pulse_Sampling_Mode == true ) { // Uses pulse interrupt to control timing of each individual sample taken.
       Sig1[SampleCount] = SampleCount; SampleCount=SampleCount+1;  // Fake Pulse driven sampling.
       if (SampleCount == MaxSamples) { Pulse_Sampling_Mode = false; be_app->PostMessage(MENU_PULSE_OFF); be_app->PostMessage(APP_SCAN_PLOT); SampleCount = 0; } }
    if (Pulse_Scan_Mode == true ) { System_Free = false; be_app->PostMessage(APP_SCAN_PLOT); } } // Uses pulse interrupt to control timing of an entire block (800 elements) of samples being scanned in.
 if (DeBug && 16 ) { beep(); } // Audio feedback of system pulse.
 PulseCount++; } // Process a pulse to do a scan.
